/*
 * Example.java
 *
 */

package quick;

import java.util.List;
import java.util.Properties;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;

public class Example {
    
    EntityManagerFactory emf;
    
    public Example()
    {
        emf=Persistence.createEntityManagerFactory("example",new Properties());
    }
    
    public void exercise()
    {
        Address address=addAddress("ZZ9 ZZZ","Beeblebrox Street");
        
        Address address2=findByPostcode("ZZ9 ZZZ");
        System.out.println("Saved address "+address2);
        
        Person p=new Person();
        p.setName("John Doe");
        p.setAddress(address);
        savePerson(p);
        
        Person pa=new Person();
        pa.setName("Fred Bloggs");
        pa.setAddress(null);
        savePerson(pa);
        
        Person pb=new Person();
        pb.setName("ALF");
        pb.setAddress(address);
        savePerson(pb);
        
        Person px=findByName("ALF");
        System.out.println(px);
        Address anotheraddress=addAddress("AA9 AAA","Sesame Street");
        
        px.setAddress(anotheraddress);
        savePerson(px);
        
        Person py=findByName("ALF");
        System.out.println(py);
   
        emf.close();
    }

    private Person findByName(String name) {
        
        EntityManager em=emf.createEntityManager();
        Query q=em.createQuery("select person from Person as person where name=:param");
        q.setParameter("param",name);
        Person p=(Person)q.getSingleResult();
        em.close();
        return p;
    }
    
      private Address findByPostcode(String postcode) {
        
        EntityManager em=emf.createEntityManager();
        Query q=em.createQuery("select address from Address as address where postcode=:param");
        q.setParameter("param",postcode);
        Address address=(Address)q.getSingleResult();
        em.close();
        return address;
    }
    private Person findById(Long id) {
        
        EntityManager em=emf.createEntityManager();
        Person p=em.find(Person.class,id);
        em.close();
        return p;
    }

    private Long savePerson(final Person p) {
        EntityManager em=emf.createEntityManager();
        
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        Person pp=em.merge(p);
        tx.commit();
        
        em.close();
        
        return pp.getId();
    }
        
    private Address addAddress(String postcode,String street)
    {
        EntityManager em=emf.createEntityManager();
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        Address address=new Address();
        address.setPostcode(postcode);
        address.setStreet(street);
        em.persist(address);
        tx.commit();
        em.close();
        return address;
    }
 
    
    public static void main(String[] args)
    {
       new Example().exercise();
        try {
            Thread.sleep(30000);
        } catch (InterruptedException ex) {
        }
    }
    
    
}
